OpenVDB: Value< T > Struct Template Reference

OpenVDB 11.0.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Attributes | List of all members
Value< T > Struct Template Reference

A Value (literal) AST node holds either literal text or absolute value information on all numerical, string and boolean constants. A single instance of a Value is templated on the requested scalar, boolean or string type. If scalar or boolean value is constructed from a string (as typically is the case in the parser), the value is automatically converted to its numerical representation. If this fails, the original text is stored instead. More...

`#include <openvdb_ax/ast/AST.h>`

Inheritance diagram for Value< T >:

## Public Types
using | UniquePtr = std::unique_ptr<Value<T>>
using | Type = T
using | ContainerType
| Integers and Floats store their value as ContainerType, which is guaranteed to be at least large enough to represent the maximum possible supported type for the requested precision.
enum | NodeType { TreeNode , StatementListNode , BlockNode , ConditionalStatementNode , CommaOperatorNode , LoopNode , KeywordNode , AssignExpressionNode , CrementNode , UnaryOperatorNode , BinaryOperatorNode , TernaryOperatorNode , CastNode , AttributeNode , FunctionCallNode , ExternalVariableNode , DeclareLocalNode , ArrayPackNode , ArrayUnpackNode , LocalNode , ValueBoolNode , ValueInt16Node , ValueInt32Node , ValueInt64Node , ValueFloatNode , ValueDoubleNode , ValueStrNode }
| An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType. More...
using | Ptr = std::shared_ptr<Node>

## Public Member Functions
| Value (const ContainerType value)
| Directly construct a Value from a source integer, float or boolean, guaranteeing valid construction. Note that the provided argument should not be negative.
| Value (const Value< T > &other)
| Deep copy constructor for a Value.
| ~Value () override=default
Value< Type > * | copy () const override final
| The deep copy method for a Node.
NodeType | nodetype () const override
| Virtual method for accessing node type information.
const char * | nodename () const override
| Virtual method for accessing node name information.
const char * | subname () const override
| Virtual method for accessing node name information.
const ValueBase * | basetype () const override
| Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.
ContainerType | asContainerType () const
| Access the value as its stored type.
T | value () const
| Access the value as its requested (templated) type.
size_t | children () const override
| Virtual method for accessing child information. Returns the number of children a given AST node owns.
const Node * | child (const size_t) const override
| Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.
Name/Type
template<typename NodeT >
bool | isType () const
| Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype()
Child Queries
int64_t | childidx () const
| Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree)
Replacement
bool | replace (Node *node)
| In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.
virtual bool | replacechild (const size_t index, Node *node)
| Virtual method that attempted to replace a child at a given index with a provided node type.
Parent
const Node * | parent () const
| Access a const pointer to this nodes parent.
void | setParent (Node *parent)
| Set this node's parent. This is used during construction of an AST and should not be used.

## Static Public Attributes
static constexpr bool | IsSupported
| The list of supported numerical constants.

## Detailed Description

template<typename T>
struct openvdb::v11_0::ax::ast::Value< T >

A Value (literal) AST node holds either literal text or absolute value information on all numerical, string and boolean constants. A single instance of a Value is templated on the requested scalar, boolean or string type. If scalar or boolean value is constructed from a string (as typically is the case in the parser), the value is automatically converted to its numerical representation. If this fails, the original text is stored instead.

Note
  All numerical values are stored as their highest possible precision type to support overflowing without storing the original string data. The original string data is only required if the value is too large to be stored in these highest precision types (usually a uint64_t for scalars or double for floating points).
  Numerical values are guaranteed to be positive (if constructed from the AX parser). Negative values are represented by a combination of a UnaryOperator holding a Value AST node.
  Note that Value AST nodes representing strings are specialized and are guranteed to be "well-formed" (there is no numerical conversion)
  A Value is a complete "leaf-level" AST node. It has no children and nothing derives from it.

## Member Typedef Documentation

## ◆ ContainerType

template<typename T >

using ContainerType

Initial value:
typename std::conditional<
std::is_integral<T>::value, uint64_t, T>::type

Integers and Floats store their value as ContainerType, which is guaranteed to be at least large enough to represent the maximum possible supported type for the requested precision.

## ◆ Ptr

using Ptr = std::shared_ptr<Node>
| inherited

## ◆ Type

template<typename T >

using Type = T

## ◆ UniquePtr

template<typename T >

using UniquePtr = std::unique_ptr<Value<T>>

## Member Enumeration Documentation

## ◆ NodeType

enum NodeType
| inherited

An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType.

Note
  This is sometimes referred to as "manual RTTI". We use this technique combine with single dispatch due to opting for CRTP on the main visitor and no templated virtual method support in C++. i.e. no way to double dispatch: visit<template T>(Visitor<T>*)
  Abstract (pure-virtual) nodes are not listed here. Node::isType should be used to determine if a node is of a given abstract type.

Enumerator
TreeNode |
StatementListNode |
BlockNode |
ConditionalStatementNode |
CommaOperatorNode |
LoopNode |
KeywordNode |
AssignExpressionNode |
CrementNode |
UnaryOperatorNode |
BinaryOperatorNode |
TernaryOperatorNode |
CastNode |
AttributeNode |
FunctionCallNode |
ExternalVariableNode |
DeclareLocalNode |
ArrayPackNode |
ArrayUnpackNode |
LocalNode |
ValueBoolNode |
ValueInt16Node |
ValueInt32Node |
ValueInt64Node |
ValueFloatNode |
ValueDoubleNode |
ValueStrNode |

## Constructor & Destructor Documentation

## ◆ Value() [1/2]

template<typename T >

Value | ( | const ContainerType | value | ) |
| inline

Directly construct a Value from a source integer, float or boolean, guaranteeing valid construction. Note that the provided argument should not be negative.

## ◆ Value() [2/2]

template<typename T >

Value | ( | const Value< T > & | other | ) |
| inline

Deep copy constructor for a Value.

Note
  No parent information needs updating as a Value is a "leaf level" node (contains no children)

Parameters

  other | A const reference to another Value to deep copy

## ◆ ~Value()

template<typename T >

~Value | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ asContainerType()

template<typename T >

ContainerType asContainerType | ( |  | ) | const
| inline

Access the value as its stored type.

Returns
  The value as its stored ContainerType

## ◆ basetype()

template<typename T >

const ValueBase * basetype | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.

Reimplemented from Expression.

## ◆ child()

const Node * child | ( | const size_t | index | ) | const
| inlineoverridevirtualinherited

Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.

Note
  This may still return a nullptr even if the given index is valid if the child node has not been created.

Parameters

  index | The child index to query

Returns
  A Pointer to the child node, or a nullptr if none exists.

Implements Node.

## ◆ childidx()

int64_t childidx | ( |  | ) | const
| inlineinherited

Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree)

Returns
  The child index of this node

## ◆ children()

size_t children | ( |  | ) | const
| inlineoverridevirtualinherited

Virtual method for accessing child information. Returns the number of children a given AST node owns.

Returns
  The number of children this node owns.

Implements Node.

## ◆ copy()

template<typename T >

Value< Type > * copy | ( |  | ) | const
| inlinefinaloverridevirtual

The deep copy method for a Node.

Implements ValueBase.

## ◆ isType()

template<typename NodeT >

bool isType | ( |  | ) | const
| inlineinherited

Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype()

Template Parameters

  NodeT | The node type to query against.

Returns
  True if this node is of the given type, false otherwise.

## ◆ nodename()

template<typename T >

const char * nodename | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node name information.

Implements Node.

## ◆ nodetype()

template<typename T >

NodeType nodetype | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node type information.

Implements Node.

## ◆ parent()

const Node * parent | ( |  | ) | const
| inlineinherited

Access a const pointer to this nodes parent.

Note
  Can be a nullptr if this is the top most node in an AST (usually a Tree)

Returns
  A const pointer to this node's parent node

## ◆ replace()

bool replace | ( | Node * | node | ) |
| inlineinherited

In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.

Note
  A replacement will fail if this node is the top most node within an AST hierarchy or if the provided node type is not a compatible type for the required abstract storage. For example, if this node is an Attribute being held on a BinaryOperator, only concrete nodes derived from an Expression can be used as a replacement.
  This method will dynamic_cast the provided node to check to see if it's a compatible type.

Parameters

  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, resulting in destruction of this class and ownership transferal of the provided node. False otherwise, where this and the provided node are unchanged.

## ◆ replacechild()

bool replacechild | ( | const size_t | index,
|  | Node * | node )
| inlinevirtualinherited

Virtual method that attempted to replace a child at a given index with a provided node type.

Note
  See Node::replace for a more detailed description

Parameters

  index | The child index where a replacement should be attempted
  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, false otherwise

Reimplemented in ArrayPack, ArrayUnpack, AssignExpression, BinaryOperator, Block, Cast, CommaOperator, ConditionalStatement, Crement, DeclareLocal, FunctionCall, Loop, StatementList, TernaryOperator, and UnaryOperator.

## ◆ setParent()

void setParent | ( | Node * | parent | ) |
| inlineinherited

Set this node's parent. This is used during construction of an AST and should not be used.

Parameters

  parent | The parent to set

## ◆ subname()

template<typename T >

const char * subname | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node name information.

Implements Node.

## ◆ value()

template<typename T >

T value | ( |  | ) | const
| inline

Access the value as its requested (templated) type.

Returns
  The value as its templed type T

## Member Data Documentation

## ◆ IsSupported

template<typename T >

bool IsSupported
| staticconstexpr

Initial value:
=
std::is_same<T, bool>::value ||
std::is_same<T, int16_t>::value ||
std::is_same<T, int32_t>::value ||
std::is_same<T, int64_t>::value ||
std::is_same<T, float>::value ||
std::is_same<T, double>::value

The list of supported numerical constants.

Note
  Strings are specialized and handled separately